/*
    Build in a Visual Studio Tools command prompt by
    cl /D WINDOWS /MT /EHsc run.cpp
 */

#include <windows.h>
#include <string>
#include <fstream>
#include <cstdlib>
// #define DEBUG
#define BUFFER_SIZE 1024
/*
    learned at
        http://stackoverflow.com/questions/875249/how-to-get-current-directory
 */
std::string GetExeFileName()
{
    char buffer[MAX_PATH];
    GetModuleFileName( NULL, buffer, MAX_PATH );
    return std::string(buffer);
}

std::string GetExePath() 
{
    std::string f = GetExeFileName();
    return f.substr(0, f.find_last_of( "\\/" ));
}

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE, PWSTR pCmdLine, int nCmdShow)
{
    size_t  i;
    char    mb_command_line_args_[BUFFER_SIZE];
    wcstombs_s(&i, mb_command_line_args_, (size_t)BUFFER_SIZE, pCmdLine, (size_t)BUFFER_SIZE );
    std::string command_line_args_( mb_command_line_args_ );

#if ( defined DEBUG )
    std::ofstream ofs_( "test.txt" );
    ofs_ << GetExeFileName() << std::endl;
    ofs_ << GetExePath() << std::endl;
    ofs_ << command_line_args_ << std::endl;
#endif
    std::string exe_name_;
    DWORD dwCreationFlags_;
    if (   command_line_args_.find( "--command" ) != std::string::npos
        || command_line_args_.find( "-c" ) != std::string::npos
    )
    {
        // with console
        exe_name_           = "autorg_kek_gui.exe";
        dwCreationFlags_    = CREATE_NEW_CONSOLE;
    }
    else
    {
        // without console
        exe_name_           = "autorg_kek_guiw.exe";
        dwCreationFlags_    = CREATE_NO_WINDOW;         // valid as of VS 2015
    }
#if ( defined DEBUG )
    ofs_ << "exe_name_=" << exe_name_ << std::endl;
    std::string application_name_   ( "C:\\Program Files\\Python36\\python.exe" );
    std::string command_line_       = std::string( "python.exe print_argv.py " ) + command_line_args_;
#else
    std::string application_name_   = GetExePath() + "\\executables\\" + exe_name_;
    std::string command_line_       = exe_name_ + " " + command_line_args_;
#endif
    /*
        learned at
            http://stackoverflow.com/questions/42531/how-do-i-call-createprocess-in-c-to-launch-a-windows-executable
     */
    STARTUPINFO info={sizeof(info)};
    PROCESS_INFORMATION processInfo;
    if  (
            CreateProcess(
                (char*)application_name_.c_str(),
                (char*)command_line_.c_str(),
                NULL, NULL, TRUE, dwCreationFlags_, NULL, NULL, &info, &processInfo )
        )
    {
        ::WaitForSingleObject(processInfo.hProcess, INFINITE);
        CloseHandle(processInfo.hProcess);
        CloseHandle(processInfo.hThread);
    }
    return 0;
}
