# -*- coding: utf-8 -*-
"""

    ファイル名：   OurNavigationToolbar.py

    処理内容：

       NavigationToolbar2TkAgg のカスタマイズ（Windows のみ）
       Ubuntu では元の NavigationToolbar2TkAgg で OK

"""
from __future__ import division, print_function, unicode_literals
import os
import sys
import numpy as np
import pylab as pl

from matplotlib.backends.backend_tkagg import NavigationToolbar2TkAgg

class NavigationToolbar( NavigationToolbar2TkAgg ):
    def __init__( self, canvas, window ):
        NavigationToolbar2TkAgg.__init__( self, canvas, window )

    """
        matplotlib.backend_bases.NavigationToolbar2.mouse_move を override
    """
    def mouse_move(self, event):
        self._set_cursor(event)

        if event.inaxes and event.inaxes.get_navigate():

            try:
                s = event.inaxes.format_coord(event.xdata, event.ydata)
            except (ValueError, OverflowError):
                pass
            else:

                # s += している部分を削除

                if len(self.mode):
                    self.set_message('%s, %s' % (self.mode, s))
                else:
                    self.set_message(s)
        else:
            self.set_message(self.mode)
